// gcc -o sum.x -Wall sum.c


#include <stdlib.h>   // always necessary
#include <stdio.h>    // always necessary
#include <time.h>     // for time()


int main(int argc, char *argv[] )
{
   int i, j, k;
   int m, n;
   double *A, *B, *C, *D;  
   double ctime;

   // random number generator
   srand48( (unsigned)time((time_t *)NULL) ); 
   // srand48  initializes the seed of the generator


   if(argc < 3) { printf(" Two arguments needed!\n"); return(-1); }
   if(argc == 3) {
      m = atoi(argv[1]);
      n = atoi(argv[2]);
   }

   A = (double *) malloc( m*n * sizeof(double) );
   B = (double *) malloc( m*n * sizeof(double) );   
   C = (double *) malloc( m*n * sizeof(double) );   
   D = (double *) malloc( m*n * sizeof(double) );   

   // MATRIX INIT
   for( j=0; j<n; j++ )
     for( i=0; i<m; i++ )
       {
	  printf(" idx: %d\n", i*m+j );
	  A[i+j*m] = 1.0 * i*n+j +1;  
	  B[i+j*m] = drand48();  
	 // drand48()  returns a random real uniformly distributed in ]0..1[ 
       }
   
   // cache thrashing ?

   ctime = ((double) clock ())/CLOCKS_PER_SEC;

   for( j=0; j<n; j++ )
     for( i=0; i<m; i++ )
       {
	 C[i+j*m] = A[i+j*m] + B[i+j*m];
       }

   printf(" %d x %d:   ctime= %.5g\n", m, n, 
	  (((double) clock ())/CLOCKS_PER_SEC) - ctime);


   ctime = ((double) clock ())/CLOCKS_PER_SEC;

   for( i=0; i<m; i++ )
     for( j=0; j<n; j++ )
       {
	 D[i+j*m] = A[i+j*m] + B[i+j*m];
       }

   printf(" %d x %d:   ctime= %.5g\n", m, n, 
	  (((double) clock ())/CLOCKS_PER_SEC) - ctime);



   free( A );
   free( B );
   free( C );
   free( D );


   return( 0 );
}

