/*
 Languages for Scientific Computing
 ----
*/
// to compile:
// gcc -o outputname -Wall test11.c 

#include <stdlib.h>   // (almost) always necessary
#include <stdio.h>    // (almost) always necessary
#include <math.h>     // pow

int printvector( double* vector, char *name, int n );


int main(int argc, char *argv[] )
{
  // #11
  // dynamic memory allocation
  // definition of arrays (matrices, vectors... )

   int i, n;
   
   if(argc == 1) 
     {
       printf(" argument needed: pass me an integer\n");
       return( -1 );
     }
   else  
      n = atoi(argv[1]);
   
   double *M;  // M will be our vector
   
   // malloc allocates a block of contiguous memory
   M = (double *) malloc( n * sizeof(double) );
   // the unit of malloc and sizeof is the byte

   if(M == NULL) {
      fprintf(stderr, 
	      "Not enough memory to allocate %ld bytes.", 
	      n * sizeof(double)
	      );
      return( 1 );
   }

   printvector( M, "vecInit", n ); 

   for( i=0; i<n; i++ )   M[i] = sqrt(i);
   
   printvector( M, "vecSqrt", n ); 
   
   printvector( M, "vecSqrt", n+2 ); 

   for( i=0; i<n; i++ )   M[i] = pow(M[i],2);

   printvector( M, "vecPow", n ); 
   
   // if I don't use M anymore, I should release the memory
   free( M );   

   
   return( 0 );
}




int printvector( double* vector, char *name, int n )
{
   int i;

   printf(" %s = [", name );
   for( i=0; i<n; i++ ) printf("%g ", vector[i] );
   printf("];\n");

   return( 0 );
}


