/*
 Languages for Scientific Computing
 ----
*/
// to compile:
// gcc testb8.c -o outputname -Wall 


#include <stdlib.h>   // (almost) always necessary
#include <stdio.h>    // (almost) always necessary
#include <time.h>
#include <math.h>     // for PI


  #define get_ticks(var) { \
      unsigned int __a, __d; \
      asm volatile("rdtsc" : "=a" (__a), "=d" (__d)); \
      var = ((unsigned long) __a) | (((unsigned long) __d) << 32); \
  } while(0)



int main(  )
{
  // #8  high-precision timer
  
  double ctime;
  int i,j,l;

  unsigned long ticks0, ticks1; 

  ctime = ((double) clock ())/CLOCKS_PER_SEC;

  get_ticks(ticks0);   

  for( i=0; i<1000; i++ )
     for( j=0; j<1000; j++ )
	for( l=0; l<1000; l++ )
	 ;  //doing nothing  
  

  get_ticks(ticks1); 

  unsigned long ticks = ticks1 - ticks0; 


  printf(" ctime= %.5lf\n",
	  (((double) clock ())/CLOCKS_PER_SEC) - ctime);
  

  printf(" Gtime= %.5ld\n", ticks );

  return( 0 );
}

